package net.ibizsys.central.plugin.boot.core.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import net.ibizsys.central.dataentity.IDataEntityRuntime;
import net.ibizsys.central.dataentity.IDataEntityRuntimeContext;
import net.ibizsys.central.plugin.boot.core.domain.BaseData;
import net.ibizsys.central.plugin.boot.core.filter.BaseFilter;
import net.ibizsys.central.plugin.boot.core.runtime.IBootService;
import net.ibizsys.central.plugin.boot.core.runtime.IBootSystemRuntime;
import net.ibizsys.model.dataentity.action.IPSDEAction;
import net.ibizsys.model.dataentity.ds.IPSDEDataSet;
import org.springframework.data.domain.Page;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public interface IMPService<T extends BaseData, F extends BaseFilter, M extends BaseMapper<T>> extends IBaseService<T,F>{

    default M getBaseMapper(){
        return null;
    }

    default List<T> list(QueryWrapper<T> queryWrapper) {
        return this.getBaseMapper().selectList(queryWrapper);
    }

    default Integer count(QueryWrapper<T> queryWrapper) {
        return this.getBaseMapper().selectCount(queryWrapper);
    }

    default T getOne(QueryWrapper<T> queryWrapper) {
        return this.getBaseMapper().selectOne(queryWrapper);
    }

    default <K extends Serializable> T getById(K key) {
        return this.getBaseMapper().selectById(key);
    }
}
